/*
   Projet IFT763 : Objets volant avec Verlet / Contraintes

   (C) Eric Beaudry 2004.
   Eric.Beaudry@USherbrooke.ca
   http://siela.dmi.usherb.ca/~eric/

   Universit de Sherbrooke
   Facult des Sciences
   Dpartement d'Informatique

*/


#if !defined(__PARACHUTE_H__)
#define __PARACHUTE_H__

#include "object.h"
#include "physic.h"

class CircularParachute : public Object{
  public:
     CircularParachute(const Point& centre, int nblevel=5, double rayon=2, double massperson=50, double mass=5.0);
     virtual ~CircularParachute();

     void                 registerInSimulator(PhysicSimulatorVerlet* sim);

     Point                getPos() const { return person.pos;}

     virtual void         renderGL() const;

  protected:
     Particule*     particules;
     Particule      person;
     int            nbParticules;
     int            nbLevel;
     int            ropesRes;

     Vector*        normals;
};


#endif
