/*
   Projet IFT763 : Objets volant avec Verlet / Contraintes

   (C) Eric Beaudry 2004.
   Eric.Beaudry@USherbrooke.ca
   http://planiart.usherbrooke.ca/~eric/

   Universit de Sherbrooke
   Facult des Sciences
   Dpartement d'Informatique

*/

#include <GL/glut.h>
#include <iostream>

#include "displayglut.h"
#include "parachute.h"
#include "timer.h"
#include "terrain.h"

Terrain2*                 terrain;
CircularParachute*        parachute;
CircularParachute*        parachute2;
//PhysicSimulatorEuler*   simulator;
PhysicSimulatorVerlet*    simulator;
Timer                     timer;

void idle(){
   int n = timer.getNbStepToDo();
   if(n>0){
      for(int i=0;i<n;i++){
         simulator->iter();
      }
      Point pos = parachute->getPos(); //kite->getPos();
      setPos(pos.x, pos.y, pos.z);
      //std::cout << "Step : " << step << std::endl;
      glutPostRedisplay();
   }else{
      //timer.waitUnitNextStep();
   }
}

int main(int argc, char** argv){

   terrain = new Terrain2();
   simulator = new PhysicSimulatorVerlet();
   simulator->setWind(Vector(0, 0, 0));

   parachute = new CircularParachute(Point(0,0,50), 6, 1.4, 50, 15);
   parachute2 = new CircularParachute(Point(5,2,50), 6, 1.5, 30, 20);
   parachute->registerInSimulator(simulator);
   parachute2->registerInSimulator(simulator);

   addObject(terrain);
   addObject(parachute);
   addObject(parachute2);

   //showPhysicSim(simulator);

   createGlut(&argc, argv);
   glClearColor(0.3, 0.4, 0.85, 0);
   glutIdleFunc(idle);
   simulator->init();
   timer.reset();
   glutMainLoop();

   delete terrain;
   delete parachute;
   delete parachute2;
   delete simulator;

   return 0;
}

